Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/mpp.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 5213)
@@ -1148,132 +1407,135 @@
             &     il_area,                         &
             &     il_iglo, il_jglo,                &
-            &     mpp__init_read_rstdimg%t_proc(:)%i_lci,    &
-            &     mpp__init_read_rstdimg%t_proc(:)%i_lcj,    &
-            &     mpp__init_read_rstdimg%t_proc(:)%i_ldi,    &
-            &     mpp__init_read_rstdimg%t_proc(:)%i_ldj,    &
-            &     mpp__init_read_rstdimg%t_proc(:)%i_lei,    &
-            &     mpp__init_read_rstdimg%t_proc(:)%i_lej,    &
-            &     mpp__init_read_rstdimg%t_proc(:)%i_impp,   &
-            &     mpp__init_read_rstdimg%t_proc(:)%i_jmpp
+            &     mpp__init_file_rstdimg%t_proc(:)%i_lci,    &
+            &     mpp__init_file_rstdimg%t_proc(:)%i_lcj,    &
+            &     mpp__init_file_rstdimg%t_proc(:)%i_ldi,    &
+            &     mpp__init_file_rstdimg%t_proc(:)%i_ldj,    &
+            &     mpp__init_file_rstdimg%t_proc(:)%i_lei,    &
+            &     mpp__init_file_rstdimg%t_proc(:)%i_lej,    &
+            &     mpp__init_file_rstdimg%t_proc(:)%i_impp,   &
+            &     mpp__init_file_rstdimg%t_proc(:)%i_jmpp
             CALL fct_err(il_status)
             IF( il_status /= 0 )THEN
-               CALL logger_error("INIT READ: read first line of "//&
+               CALL logger_error("MPP INIT READ: read first line of "//&
                &              TRIM(td_file%c_name))
             ENDIF
 
-            ! mpp dimension
+            ! global domain size
             tl_dim=dim_init('X',il_iglo)
-            CALL mpp_add_dim(mpp__init_read_rstdimg,tl_dim)
+            CALL mpp_add_dim(mpp__init_file_rstdimg,tl_dim)
             tl_dim=dim_init('Y',il_jglo)
-            CALL mpp_add_dim(mpp__init_read_rstdimg,tl_dim)
-
-            DO ji=1,mpp__init_read_rstdimg%i_nproc
+            CALL mpp_add_dim(mpp__init_file_rstdimg,tl_dim)
+
+            tl_dim=dim_init('Z',il_nz)
+            CALL mpp_add_dim(mpp__init_file_rstdimg,tl_dim)
+
+            DO ji=1,mpp__init_file_rstdimg%i_nproc
                ! get file name
                cl_file =  file_rename(td_file%c_name,ji)
-               mpp__init_read_rstdimg%t_proc(ji)%c_name = TRIM(cl_file)
+               mpp__init_file_rstdimg%t_proc(ji)%c_name = TRIM(cl_file)
                ! update processor id
-               mpp__init_read_rstdimg%t_proc(ji)%i_pid=ji
+               mpp__init_file_rstdimg%t_proc(ji)%i_pid=ji
 
                ! add attributes
                tl_att=att_init( "DOMAIN_number", ji )
-               CALL file_move_att(mpp__init_read_rstdimg%t_proc(ji), tl_att) 
+               CALL file_move_att(mpp__init_file_rstdimg%t_proc(ji), tl_att) 
 
                tl_att=att_init( "DOMAIN_position_first", &
-               &                (/mpp__init_read_rstdimg%t_proc(ji)%i_impp, &
-               &                  mpp__init_read_rstdimg%t_proc(ji)%i_jmpp /) )
-               CALL file_move_att(mpp__init_read_rstdimg%t_proc(ji), tl_att)
+               &                (/mpp__init_file_rstdimg%t_proc(ji)%i_impp, &
+               &                  mpp__init_file_rstdimg%t_proc(ji)%i_jmpp /) )
+               CALL file_move_att(mpp__init_file_rstdimg%t_proc(ji), tl_att)
 
                tl_att=att_init( "DOMAIN_position_last", &
-               &                (/mpp__init_read_rstdimg%t_proc(ji)%i_lci, &
-               &                  mpp__init_read_rstdimg%t_proc(ji)%i_lcj /) )
-               CALL file_move_att(mpp__init_read_rstdimg%t_proc(ji), tl_att)
+               &                (/mpp__init_file_rstdimg%t_proc(ji)%i_lci, &
+               &                  mpp__init_file_rstdimg%t_proc(ji)%i_lcj /) )
+               CALL file_move_att(mpp__init_file_rstdimg%t_proc(ji), tl_att)
 
                tl_att=att_init( "DOMAIN_halo_size_start", &
-               &                (/mpp__init_read_rstdimg%t_proc(ji)%i_ldi, &
-               &                  mpp__init_read_rstdimg%t_proc(ji)%i_ldj /) )
-               CALL file_move_att(mpp__init_read_rstdimg%t_proc(ji), tl_att)               
+               &                (/mpp__init_file_rstdimg%t_proc(ji)%i_ldi, &
+               &                  mpp__init_file_rstdimg%t_proc(ji)%i_ldj /) )
+               CALL file_move_att(mpp__init_file_rstdimg%t_proc(ji), tl_att)               
 
                tl_att=att_init( "DOMAIN_halo_size_end", &
-               &                (/mpp__init_read_rstdimg%t_proc(ji)%i_lei, &
-               &                  mpp__init_read_rstdimg%t_proc(ji)%i_lej /) )
-               CALL file_move_att(mpp__init_read_rstdimg%t_proc(ji), tl_att)
+               &                (/mpp__init_file_rstdimg%t_proc(ji)%i_lei, &
+               &                  mpp__init_file_rstdimg%t_proc(ji)%i_lej /) )
+               CALL file_move_att(mpp__init_file_rstdimg%t_proc(ji), tl_att)
             ENDDO
-      
+ 
             ! add type
-            mpp__init_read_rstdimg%t_proc(:)%c_type="dimg"
+            mpp__init_file_rstdimg%t_proc(:)%c_type="dimg"
 
             ! add attributes
             tl_att=att_init( "DOMAIN_size_global", &
-            &                mpp__init_read_rstdimg%t_dim(:)%i_len)
-            CALL mpp_move_att(mpp__init_read_rstdimg, tl_att)
+            &                mpp__init_file_rstdimg%t_dim(:)%i_len)
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
 
             tl_att=att_init( "DOMAIN_number_total", &
-            &                 mpp__init_read_rstdimg%i_nproc )
-            CALL mpp_add_att(mpp__init_read_rstdimg, tl_att)
+            &                 mpp__init_file_rstdimg%i_nproc )
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
 
             tl_att=att_init( "DOMAIN_I_number_total", &
-            &                 mpp__init_read_rstdimg%i_niproc )
-            CALL mpp_add_att(mpp__init_read_rstdimg, tl_att)
+            &                 mpp__init_file_rstdimg%i_niproc )
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
 
             tl_att=att_init( "DOMAIN_J_number_total", &
-            &                 mpp__init_read_rstdimg%i_njproc )
-            CALL mpp_add_att(mpp__init_read_rstdimg, tl_att)
+            &                 mpp__init_file_rstdimg%i_njproc )
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
 
             tl_att=att_init( "DOMAIN_I_position_first", &
-            &                 mpp__init_read_rstdimg%t_proc(:)%i_impp )
-            CALL mpp_add_att(mpp__init_read_rstdimg, tl_att)
+            &                 mpp__init_file_rstdimg%t_proc(:)%i_impp )
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
 
             tl_att=att_init( "DOMAIN_J_position_first", &
-            &                 mpp__init_read_rstdimg%t_proc(:)%i_jmpp )
-            CALL mpp_add_att(mpp__init_read_rstdimg, tl_att)
+            &                 mpp__init_file_rstdimg%t_proc(:)%i_jmpp )
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
 
             tl_att=att_init( "DOMAIN_I_position_last", &
-            &                 mpp__init_read_rstdimg%t_proc(:)%i_lci )
-            CALL mpp_add_att(mpp__init_read_rstdimg, tl_att)
+            &                 mpp__init_file_rstdimg%t_proc(:)%i_lci )
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
 
             tl_att=att_init( "DOMAIN_J_position_last", &
-            &                 mpp__init_read_rstdimg%t_proc(:)%i_lcj )
-            CALL mpp_add_att(mpp__init_read_rstdimg, tl_att)
+            &                 mpp__init_file_rstdimg%t_proc(:)%i_lcj )
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
 
             tl_att=att_init( "DOMAIN_I_halo_size_start", &
-            &                 mpp__init_read_rstdimg%t_proc(:)%i_ldi )
-            CALL mpp_add_att(mpp__init_read_rstdimg, tl_att)
+            &                 mpp__init_file_rstdimg%t_proc(:)%i_ldi )
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
 
             tl_att=att_init( "DOMAIN_J_halo_size_start", &
-            &                 mpp__init_read_rstdimg%t_proc(:)%i_ldj )
-            CALL mpp_add_att(mpp__init_read_rstdimg, tl_att)
+            &                 mpp__init_file_rstdimg%t_proc(:)%i_ldj )
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
 
             tl_att=att_init( "DOMAIN_I_halo_size_end", &
-            &                 mpp__init_read_rstdimg%t_proc(:)%i_lei )
-            CALL mpp_add_att(mpp__init_read_rstdimg, tl_att)
+            &                 mpp__init_file_rstdimg%t_proc(:)%i_lei )
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
 
             tl_att=att_init( "DOMAIN_J_halo_size_end", &
-            &                 mpp__init_read_rstdimg%t_proc(:)%i_lej )
-            CALL mpp_add_att(mpp__init_read_rstdimg, tl_att)
+            &                 mpp__init_file_rstdimg%t_proc(:)%i_lej )
+            CALL mpp_move_att(mpp__init_file_rstdimg, tl_att)
+
+            ! clean
+            CALL dim_clean(tl_dim)
+            CALL att_clean(tl_att)
          ENDIF
 
       ELSE
 
-         CALL logger_error("INIT READ: dimg file "//TRIM(td_file%c_name)//&
+         CALL logger_error("MPP INIT READ: dimg file "//TRIM(td_file%c_name)//&
          &  " do not exist")
 
       ENDIF
 
-   END FUNCTION mpp__init_read_rstdimg
-   ! @endcode
+   END FUNCTION mpp__init_file_rstdimg
    !-------------------------------------------------------------------
    !> @brief This function check if variable and mpp structure use same
    !> dimension.
    !
-   !> @details
-   !
    !> @author J.Paul
    !> - Nov, 2013- Initial Version
    !
-   !> @param[in] td_mpp : mpp structure
-   !> @param[in] td_proc : processor structure
+   !> @param[in] td_mpp    mpp structure
+   !> @param[in] td_proc   processor structure
    !> @return dimension of processor and mpp structure agree (or not)
    !-------------------------------------------------------------------
-   ! @code
    LOGICAL FUNCTION mpp__check_proc_dim(td_mpp, td_proc)
       IMPLICIT NONE
@@ -1301,5 +1563,5 @@
             mpp__check_proc_dim=.FALSE.
 
-            CALL logger_error( " CHECK DIM: processor and mpp dimension differ" )
+            CALL logger_error( "MPP CHECK DIM: processor and mpp dimension differ" )
 
          ENDIF
@@ -1312,5 +1574,5 @@
             mpp__check_proc_dim=.FALSE.
 
-            CALL logger_error( " CHECK DIM: processor and mpp dimension differ" )
+            CALL logger_error( "MPP CHECK DIM: processor and mpp dimension differ" )
 
          ENDIF
@@ -1318,20 +1580,14 @@
 
    END FUNCTION mpp__check_proc_dim
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief
-   !>    This subroutine add variable to mpp structure.
-   !>
-   !> @detail
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in]    td_var : variable strcuture
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
+   !>    This subroutine add variable in all files of mpp structure.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !
+   !> @param[inout] td_mpp mpp strcuture
+   !> @param[in]    td_var variable strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE mpp_add_var( td_mpp, td_var )
       IMPLICIT NONE
@@ -1350,11 +1606,6 @@
       IF( .NOT. ASSOCIATED(td_mpp%t_proc) )THEN
 
-         CALL logger_error( "MPP ADD VAR: domain decomposition not define "//&
-         &               "for mpp "//TRIM(td_mpp%c_name))
-
-      ELSEIF( td_mpp%i_ndim == 0 )THEN
-
-         CALL logger_error( " MPP ADD VAR: no dimension define for "//&
-         &               " mpp strcuture "//TRIM(td_mpp%c_name))
+         CALL logger_error( "MPP ADD VAR: processor decomposition not "//&
+         &  "define for mpp "//TRIM(td_mpp%c_name))
 
       ELSE
@@ -1367,6 +1618,6 @@
             il_varid=0
             IF( ASSOCIATED(td_mpp%t_proc(1)%t_var) )THEN
-               il_varid=var_get_id( td_mpp%t_proc(1)%t_var(:), &
-               &                    td_var%c_name, td_var%c_stdname )
+               il_varid=var_get_index( td_mpp%t_proc(1)%t_var(:), &
+               &                       td_var%c_name, td_var%c_stdname )
             ENDIF
 
@@ -1393,4 +1644,12 @@
                IF( mpp__check_dim(td_mpp, td_var) )THEN
 
+                  ! update dimension if need be
+                  DO ji=1,ip_maxdim
+                     IF( td_var%t_dim(ji)%l_use .AND. &
+                     &   .NOT. td_mpp%t_dim(ji)%l_use )THEN
+                        CALL mpp_add_dim(td_mpp,td_var%t_dim(ji))
+                     ENDIF
+                  ENDDO
+
                   ! add variable in each processor
                   DO ji=1,td_mpp%i_nproc
@@ -1401,4 +1660,6 @@
                      CALL file_add_var(td_mpp%t_proc(ji), tl_var)
 
+                     ! clean
+                     CALL var_clean(tl_var)
                   ENDDO
 
@@ -1409,20 +1670,16 @@
 
    END SUBROUTINE mpp_add_var
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This function extract from variable structure, part that will 
+   !-------------------------------------------------------------------
+   !> @brief This function extract, from variable structure, part that will 
    !> be written in processor id_procid.<br/>
    !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp : mpp structure
-   !> @param[in] td_var : variable structure
-   !> @param[in] id_procid : processor id
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_mpp    mpp structure
+   !> @param[in] td_var    variable structure
+   !> @param[in] id_procid processor id
    !> @return variable structure
    !-------------------------------------------------------------------
-   ! @code   
    TYPE(TVAR) FUNCTION mpp__split_var(td_mpp, td_var, id_procid)
       IMPLICIT NONE
@@ -1444,45 +1701,76 @@
 
       ! copy mpp
-      mpp__split_var=td_var
-
-      ! remove value over global domain from pointer
-      CALL var_del_value( mpp__split_var )
-
-      ! get processor dimension
-      il_size(:)=mpp_get_proc_size( td_mpp, id_procid )
-
-      ! define new dimension in variable structure 
-      IF( td_var%t_dim(1)%l_use )THEN
-         tl_dim=dim_init( TRIM(td_var%t_dim(1)%c_name), il_size(1) )
-         CALL var_move_dim( mpp__split_var, tl_dim )
-      ENDIF
-      IF( td_var%t_dim(2)%l_use )THEN
-         tl_dim=dim_init( TRIM(td_var%t_dim(2)%c_name), il_size(2) )
-         CALL var_move_dim( mpp__split_var, tl_dim )      
-      ENDIF
-
-      ! get processor indices
-      il_ind(:)=mpp_get_proc_index( td_mpp, id_procid )
-      il_i1 = il_ind(1)
-      il_i2 = il_ind(2)
-      il_j1 = il_ind(3)
-      il_j2 = il_ind(4)
-
-      IF( .NOT. td_var%t_dim(1)%l_use )THEN
-         il_i1=1 
-         il_i2=1 
-      ENDIF
-
-      IF( .NOT. td_var%t_dim(2)%l_use )THEN
-         il_j1=1 
-         il_j2=1 
-      ENDIF      
-
-      ! add variable value on processor
-      CALL var_add_value( mpp__split_var, &
-      &                   td_var%d_value(il_i1:il_i2, il_j1:il_j2, :, :) )
+      mpp__split_var=var_copy(td_var)
+
+      IF( ASSOCIATED(td_var%d_value) )THEN
+         ! remove value over global domain from pointer
+         CALL var_del_value( mpp__split_var )
+
+         ! get processor dimension
+         il_size(:)=mpp_get_proc_size( td_mpp, id_procid )
+
+         ! define new dimension in variable structure 
+         IF( td_var%t_dim(1)%l_use )THEN
+            tl_dim=dim_init( TRIM(td_var%t_dim(1)%c_name), il_size(1) )
+            CALL var_move_dim( mpp__split_var, tl_dim )
+         ENDIF
+         IF( td_var%t_dim(2)%l_use )THEN
+            tl_dim=dim_init( TRIM(td_var%t_dim(2)%c_name), il_size(2) )
+            CALL var_move_dim( mpp__split_var, tl_dim )      
+         ENDIF
+
+         ! get processor indices
+         il_ind(:)=mpp_get_proc_index( td_mpp, id_procid )
+         il_i1 = il_ind(1)
+         il_i2 = il_ind(2)
+         il_j1 = il_ind(3)
+         il_j2 = il_ind(4)
+
+         IF( .NOT. td_var%t_dim(1)%l_use )THEN
+            il_i1=1 
+            il_i2=1 
+         ENDIF
+
+         IF( .NOT. td_var%t_dim(2)%l_use )THEN
+            il_j1=1 
+            il_j2=1 
+         ENDIF      
+
+         ! add variable value on processor
+         CALL var_add_value( mpp__split_var, &
+         &                   td_var%d_value(il_i1:il_i2, il_j1:il_j2, :, :) )
+      ENDIF
 
    END FUNCTION mpp__split_var
-   !> @endcode
+   !-------------------------------------------------------------------
+   !> @brief 
+   !>  This subroutine delete all variable in mpp strcuture.
+   !>
+   !> @author J.Paul
+   !> @date October, 2014 - Initial version
+   !>
+   !> @param[inout] td_mpp mpp strcuture
+   !-------------------------------------------------------------------
+   SUBROUTINE mpp__del_var_mpp( td_mpp )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TMPP), INTENT(INOUT) :: td_mpp
+
+      ! local variable
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      CALL logger_info( &
+      &  "MPP CLEAN VAR: reset all variable "//&
+      &  "in mpp strcuture "//TRIM(td_mpp%c_name) )
+
+      IF( ASSOCIATED(td_mpp%t_proc) )THEN
+         DO ji=td_mpp%t_proc(1)%i_nvar,1,-1
+            CALL mpp_del_var(td_mpp, td_mpp%t_proc(1)%t_var(ji))
+         ENDDO
+      ENDIF
+
+   END SUBROUTINE mpp__del_var_mpp
    !-------------------------------------------------------------------
    !> @brief
@@ -1490,15 +1778,10 @@
    !> structure.
    !>
-   !> @detail
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in]    td_var : variable strcuture
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !
+   !> @param[inout] td_mpp mpp strcuture
+   !> @param[in]    td_var variable strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE mpp__del_var_str( td_mpp, td_var )
       IMPLICIT NONE
@@ -1517,5 +1800,5 @@
       IF( .NOT. ASSOCIATED(td_mpp%t_proc) )THEN
 
-         CALL logger_error( " DEL VAR: domain decomposition not define "//&
+         CALL logger_error( "MPP DEL VAR: domain decomposition not define "//&
          &               " in mpp strcuture "//TRIM(td_mpp%c_name))
 
@@ -1525,14 +1808,14 @@
          il_varid = 0
          IF( ASSOCIATED(td_mpp%t_proc(1)%t_var) )THEN
-            il_varid=var_get_id( td_mpp%t_proc(1)%t_var(:), &
-            &                    td_var%c_name, td_var%c_stdname )
+            il_varid=var_get_index( td_mpp%t_proc(1)%t_var(:), &
+            &                       td_var%c_name, td_var%c_stdname )
          ENDIF
          IF( il_varid == 0 )THEN
             CALL logger_error( &
-            &  " DEL VAR: no variable "//TRIM(td_var%c_name)//&
+            &  "MPP DEL VAR: no variable "//TRIM(td_var%c_name)//&
             &  ", in mpp structure "//TRIM(td_mpp%c_name) )
 
             DO ji=1,td_mpp%t_proc(1)%i_nvar
-               CALL logger_debug( " DEL VAR: in mpp structure : &
+               CALL logger_debug( "MPP DEL VAR: in mpp structure : &
                &  variable : "//TRIM(td_mpp%t_proc(1)%t_var(ji)%c_name)//&
                &  ", standard name "//&
@@ -1551,20 +1834,14 @@
       ENDIF
    END SUBROUTINE mpp__del_var_str
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !>    This subroutine delete variable in mpp structure, given variable name.
    !>
-   !> @detail
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in]    cd_name: variable name
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !
+   !> @param[inout] td_mpp    mpp strcuture
+   !> @param[in]    cd_name   variable name
+   !-------------------------------------------------------------------
    SUBROUTINE mpp__del_var_name( td_mpp, cd_name )
       IMPLICIT NONE
@@ -1579,5 +1856,5 @@
       IF( .NOT. ASSOCIATED(td_mpp%t_proc) )THEN
 
-         CALL logger_error( " DEL VAR: domain decomposition not define "//&
+         CALL logger_error( "MPP DEL VAR: domain decomposition not define "//&
          &               " in mpp strcuture "//TRIM(td_mpp%c_name))
 
@@ -1585,5 +1862,5 @@
 
          IF( td_mpp%t_proc(1)%i_nvar == 0 )THEN
-            CALL logger_debug( " DEL VAR NAME: no variable associated to mpp &
+            CALL logger_debug( "MPP DEL VAR NAME: no variable associated to mpp &
             &                 structure "//TRIM(td_mpp%c_name) )
          ELSE
@@ -1592,11 +1869,12 @@
             il_varid=0
             IF( ASSOCIATED(td_mpp%t_proc(1)%t_var) )THEN
-               il_varid=var_get_id( td_mpp%t_proc(1)%t_var(:), &
-               &                    cd_name )
-            ENDIF
+               il_varid=var_get_index( td_mpp%t_proc(1)%t_var(:), &
+               &                       cd_name )
+            ENDIF
+
             IF( il_varid == 0 )THEN
 
                CALL logger_warn( &
-               &  "DEL VAR : there is no variable with name "//&
+               &  "MPP DEL VAR : there is no variable with name "//&
                &  "or standard name "//TRIM(ADJUSTL(cd_name))//&
                &  " in mpp structure "//TRIM(td_mpp%c_name))
@@ -1611,22 +1889,14 @@
       ENDIF
    END SUBROUTINE mpp__del_var_name
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !>    This subroutine overwrite variable in mpp structure.
    !>
-   !> @detail
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in]    td_var : variable structure
-   !> @todo
-   !> - voir si il ne faut pas redefinir (__copy) variable si elle vient de mpp
-   !> exemple CALL  mpp_move_var( td_mpp, td_mpp%t_proc()%t_var )
-   !> remarque cas probabelement impossible puisque td_var doit avoir dim de td_mpp
-   !-------------------------------------------------------------------
-   !> @code
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !
+   !> @param[inout] td_mpp mpp strcuture
+   !> @param[in]    td_var variable structure
+   !-------------------------------------------------------------------
    SUBROUTINE mpp_move_var( td_mpp, td_var )
       IMPLICIT NONE
@@ -1639,5 +1909,5 @@
       !----------------------------------------------------------------
       ! copy variable
-      tl_var=td_var
+      tl_var=var_copy(td_var)
 
       ! remove processor
@@ -1647,4 +1917,7 @@
       CALL mpp_add_var(td_mpp, tl_var)
 
+      ! clean 
+      CALL var_clean(tl_var)
+
    END SUBROUTINE mpp_move_var
    !> @endcode
@@ -1653,16 +1926,13 @@
    !>    This subroutine add processor to mpp structure.
    !>
-   !> @detail
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in]    td_proc : processor strcuture
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !
+   !> @param[inout] td_mpp    mpp strcuture
+   !> @param[in]    td_proc   processor strcuture
    !
    !> @todo 
    !> - check proc type
    !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE mpp__add_proc( td_mpp, td_proc )
       IMPLICIT NONE
@@ -1698,10 +1968,10 @@
 
             CALL logger_error( &
-            &  " ADD PROC: processor "//TRIM(fct_str(td_proc%i_pid))//&
+            &  "MPP ADD PROC: processor "//TRIM(fct_str(td_proc%i_pid))//&
             &  ", already in mpp structure " )
 
       ELSE
-         
-         CALL logger_trace("ADD PROC: add processor "//&
+ 
+         CALL logger_trace("MPP ADD PROC: add processor "//&
          &               TRIM(fct_str(td_mpp%i_nproc+1))//" in mpp structure")
 
@@ -1716,16 +1986,17 @@
             IF(il_status /= 0 )THEN
 
-               CALL logger_error( " ADD PROC: not enough space to put processor &
+               CALL logger_error( "MPP ADD PROC: not enough space to put processor &
                &               in mpp structure")
 
             ELSE
                ! save temporary mpp structure
-               tl_proc(:)=td_mpp%t_proc(:)
-
-               DEALLOCATE( td_mpp%t_proc )
+               tl_proc(:)=file_copy(td_mpp%t_proc(:))
+
+               CALL file_clean( td_mpp%t_proc(:) )
+               DEALLOCATE(td_mpp%t_proc)
                ALLOCATE( td_mpp%t_proc(td_mpp%i_nproc+1), stat=il_status)
                IF(il_status /= 0 )THEN
 
-                  CALL logger_error( " ADD PROC: not enough space to put "//&
+                  CALL logger_error( "MPP ADD PROC: not enough space to put "//&
                   &  "processor in mpp structure ")
 
@@ -1733,11 +2004,13 @@
 
                ! copy processor in mpp before
-               ! processor with lesser id than new processor
-               td_mpp%t_proc( 1:il_procid ) = tl_proc( 1:il_procid )
+               ! processor with lower id than new processor
+               td_mpp%t_proc( 1:il_procid ) = file_copy(tl_proc( 1:il_procid ))
 
                ! processor with greater id than new processor
                td_mpp%t_proc( il_procid+1 : td_mpp%i_nproc+1 ) = &
-               &                 tl_proc( il_procid : td_mpp%i_nproc )
-
+               &              file_copy(tl_proc( il_procid : td_mpp%i_nproc ))
+
+               ! clean
+               CALL file_clean(tl_proc(:))
                DEALLOCATE(tl_proc)
             ENDIF
@@ -1746,4 +2019,5 @@
             ! no processor in mpp structure
             IF( ASSOCIATED(td_mpp%t_proc) )THEN
+               CALL file_clean(td_mpp%t_proc(:))
                DEALLOCATE(td_mpp%t_proc)
             ENDIF
@@ -1751,5 +2025,5 @@
             IF(il_status /= 0 )THEN
 
-               CALL logger_error( " ADD PROC: not enough space to put "//&
+               CALL logger_error( "MPP ADD PROC: not enough space to put "//&
                &  "processor in mpp structure " )
 
@@ -1759,10 +2033,10 @@
          ! check dimension
          IF( ANY(td_mpp%t_dim(1:2)%i_len < td_proc%t_dim(1:2)%i_len) )THEN
-            CALL logger_error( "ADD PROC: mpp structure and new processor "//&
+            CALL logger_error( "MPP ADD PROC: mpp structure and new processor "//&
             &  " dimension differ. ")
-            CALL logger_debug("ADD PROC: mpp dimension ("//&
+            CALL logger_debug("MPP ADD PROC: mpp dimension ("//&
             &  TRIM(fct_str(td_mpp%t_dim(1)%i_len))//","//&
             &  TRIM(fct_str(td_mpp%t_dim(2)%i_len))//")" )
-            CALL logger_debug("ADD PROC: processor dimension ("//&
+            CALL logger_debug("MPP ADD PROC: processor dimension ("//&
             &  TRIM(fct_str(td_proc%t_dim(1)%i_len))//","//&
             &  TRIM(fct_str(td_proc%t_dim(2)%i_len))//")" )
@@ -1771,25 +2045,19 @@
 
             ! add new processor
-            td_mpp%t_proc(td_mpp%i_nproc)=td_proc
+            td_mpp%t_proc(td_mpp%i_nproc)=file_copy(td_proc)
          ENDIF
 
       ENDIF
    END SUBROUTINE mpp__add_proc
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !>    This subroutine delete processor in mpp structure, given processor id.
    !>
-   !> @detail
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in]    id_procid : processor id
-   !
-   !> @todo check proc id exist
-   !-------------------------------------------------------------------
-   !> @code
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !>
+   !> @param[inout] td_mpp    mpp strcuture
+   !> @param[in]    id_procid processor id
+   !-------------------------------------------------------------------
    SUBROUTINE mpp__del_proc_id( td_mpp, id_procid )
       IMPLICIT NONE
@@ -1803,4 +2071,6 @@
       INTEGER(i4), DIMENSION(1) :: il_ind
       TYPE(TFILE), DIMENSION(:), ALLOCATABLE :: tl_proc
+
+      ! loop indices
       !----------------------------------------------------------------
 
@@ -1808,14 +2078,16 @@
       il_procid=il_ind(1)
       IF( il_procid == 0 )THEN
-         CALL logger_error("DEL PROC: no processor "//TRIM(fct_str(id_procid))//&
-         &              " associated to mpp structure")
+         CALL logger_error("MPP DEL PROC: no processor "//&
+         &                 TRIM(fct_str(id_procid))//&
+         &                 " associated to mpp structure")
       ELSE
-         CALL logger_trace("DEL PROC: remove processor "//TRIM(fct_str(id_procid)))
+         CALL logger_trace("DEL PROC: remove processor "//&
+         &                 TRIM(fct_str(id_procid)))
 
          IF( td_mpp%i_nproc > 1 )THEN
             ALLOCATE( tl_proc(td_mpp%i_nproc-1), stat=il_status )
             IF(il_status /= 0 )THEN
-               CALL logger_error( " DEL PROC: not enough space to put processor &
-               &                 in temporary mpp structure")
+               CALL logger_error( "MPP DEL PROC: not enough space to put &
+               &  processor in temporary mpp structure")
 
             ELSE
@@ -1823,22 +2095,26 @@
                ! save temporary processor's mpp structure
                IF( il_procid > 1 )THEN
-                  tl_proc(1:il_procid-1)=td_mpp%t_proc(1:il_procid-1)
+                  tl_proc(1:il_procid-1)=file_copy(td_mpp%t_proc(1:il_procid-1))
                ENDIF
-               tl_proc(il_procid:)=td_mpp%t_proc(il_procid+1:)
+
+               IF( il_procid < td_mpp%i_nproc )THEN
+                  tl_proc(il_procid:)=file_copy(td_mpp%t_proc(il_procid+1:))
+               ENDIF
 
                ! new number of processor in mpp
                td_mpp%i_nproc=td_mpp%i_nproc-1
 
-               DEALLOCATE( td_mpp%t_proc )
+               CALL file_clean( td_mpp%t_proc(:) )
+               DEALLOCATE(td_mpp%t_proc)
                ALLOCATE( td_mpp%t_proc(td_mpp%i_nproc), stat=il_status )
                IF(il_status /= 0 )THEN
 
-                  CALL logger_error( " DEL PROC: not enough space to put processors &
-                  &               in mpp structure " )
+                  CALL logger_error( "MPP DEL PROC: not enough space &
+                  &  to put processors in mpp structure " )
 
                ELSE
 
                   ! copy processor in mpp before
-                  td_mpp%t_proc(:)=tl_proc(:)
+                  td_mpp%t_proc(:)=file_copy(tl_proc(:))
 
                   ! update processor id
@@ -1848,6 +2124,10 @@
                ENDIF
             ENDIF
+            ! clean
+            CALL file_clean( tl_proc(:) )
+            DEALLOCATE(tl_proc)
          ELSE
-            DEALLOCATE( td_mpp%t_proc )
+            CALL file_clean( td_mpp%t_proc(:) )
+            DEALLOCATE(td_mpp%t_proc)
 
             ! new number of processor in mpp
@@ -1856,5 +2136,4 @@
       ENDIF
    END SUBROUTINE mpp__del_proc_id
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
